

function [k,z] = Simulation_L3(A,alpha,lss,iss,phi,gam,nu,B,delta,sigma,rho,vf,pk,D)

load epsi_test;            % Load innovations; they are normally distributed 
                           % with zero mean and unit standard deviation of 
                           % length 10,200 
T     = size(epsi_test,1); % Simulation length

% Simulate the productivity series
% --------------------------------
epsi  = epsi_test*sigma;   % Standard deviation is sigma
z(1,1)  = 1;               % Initial productivity is 1
for t = 2:T; 
   z(t,1) = z(t-1,1).^rho.*exp(epsi(t,1)); % Simulation AR(1) process
end;

% Simulate the endogenous model's variables
% -----------------------------------------
k(1,1)  = 1;               % Initial capital is 1 
for t = 1:T 
    Vder(t,1) = Polynomial_deriv_2d([k(t,1) z(t,1)],D)*vf;
    k(t+1,1) = Polynomial_2d([k(t,1) z(t,1)],D)*pk;
    k(t+1,1)= max(k(t+1,1),k(t,1)*(1-delta)+phi*iss);
    
                           % Construct the policy function
    
     n(t,1)=csolve('Labor_Newton',1-lss,[],0.000001,5,nu,gam,alpha,delta,B,A,k(t,1),z(t,1),k(t+1,1));  % Solve for labor 
     n(t,1) = min(0.95, n(t,1)); n(t,1) = max(0.01, n(t,1));                      
     
     c(t,1)= -k(t+1,1)+(1-delta)*k(t,1)+A*z(t,1).*k(t,1).^alpha.*n(t,1).^(1-alpha);
                           % Compute consumption from resource constraint
    
                           % Compute next-period capital using budget 
                           % constraint (2) in MM(2013)   
       y(t,1) = A*z(t,1).*k(t,1).^alpha.*n(t,1).^(1-alpha);
                         
end   
% for t=1:T-1
%      Vder(t+1,1) = Polynomial_deriv_2d([k(t+1,1) z(t+1,1)],D)*vf;
% Discard initial observations
% ----------------------------
discard = 200;             % The number of observations to discard in order  
                           % to eliminate the effect of initial conditions
z       = z(discard+1:T,1);
k       = k(discard+1:T,1);