function [intertemporal_errors,intratemporal_errors]=sub_foc_errors(kp,g_k,g_c,g_l,lambda,n_k,n_z,y,transition)

global  theta alpha delta beta 

 
c2=zeros(n_k,n_z); R=zeros(n_k,n_z); ctilde=zeros(n_k,n_z); ltilde=zeros(n_k,n_z); lambdap=zeros(n_k,n_z);
intertemporal_errors=zeros(n_k,n_z); intratemporal_errors=zeros(n_k,n_z); 

 for jj = 1:n_z;
 [ctilde(:,jj)]=interp1(kp, g_c(:,jj), g_k(:,jj),'pchip'); %consumption tomorrow
 [ltilde(:,jj)]=interp1(kp, g_l(:,jj), g_k(:,jj),'pchip'); %labor tomorrow
 [lambdap(:,jj)]=interp1(kp, lambda(:,jj), g_k(:,jj),'pchip'); %lambda tomorrow
 end; 

for ii = 1:n_k
     for jj = 1:n_z
    %intertemporal foc (Euler equation)
    R(ii,jj)=(alpha*exp(y(jj))*(g_k(ii,jj)^(alpha-1))*(ltilde(ii,jj)^(1-alpha))+1-delta);

     end
end

 MUp = theta.*(ctilde).^(-1);                % marginal utility tomorrow.
 c1=((1/theta).*(lambda+beta.*((R.*MUp-lambdap.*(1-delta))*transition'))).^(-1);

for ii = 1:n_k
for jj = 1:n_z

intertemporal_errors(ii,jj)=1-c1(ii,jj)/g_c(ii,jj);
    %intratemporal foc
c2(ii,jj)=(1-alpha)*exp(y(jj))*kp(ii)^(alpha)*g_l(ii,jj)^(-alpha)*(theta/(1-theta))*(1-g_l(ii,jj));   
intratemporal_errors(ii,jj)=1-c2(ii,jj)/g_c(ii,jj);
end
end


end 



