function [g_c,g_k,g_l,lambda]=sub_gti(grid_k,n_k,n_z,y,transition)


global delta alpha beta theta k_ss l_ss i_ss phi_bar
 
prob=transition;
kp=grid_k';
kpp = (k_ss^alpha)*(l_ss^(1-alpha)).*ones(n_k,n_z);%max(kp.^alpha*ones(1,n_z),(1-delta)*kp*ones(1,n_z)+phi_bar*i_ss*ones(n_k,n_z));             % Initial guess for tomorrow's policy function (here zero net-investment).
      
k = zeros(n_k,n_z);
lp = zeros(n_k,n_z);
l = zeros(n_k,n_z);
lbind = zeros(n_k,n_z);
cbind = zeros(n_k,n_z);
cp = zeros(n_k,n_z);
mp = zeros(n_k,n_z);
R = zeros(n_k,n_z);
m0=zeros(n_k,n_z);
g_c=zeros(n_k,n_z);
g_k=zeros(n_k,n_z);
g_l=zeros(n_k,n_z);
lambdap = zeros(n_k,n_z);

iter = 0;                            
                                            
d2=1; 

for j=1:n_k
        for h=1:n_z
            [lbind(j,h)]=sub_newton(kp(j),(kp(j)-phi_bar*i_ss)/(1-delta),y(h)); %labor when k'=(1-delta)k + phi_bar*i_ss
            [cbind(j,h)] = exp(y(h)).*(((kp(j)-phi_bar*i_ss)/(1-delta)).^alpha).*(lbind(j,h).^(1-alpha))-phi_bar*i_ss; %consumption when k'=(1-delta)k+ phi_bar*i_ss
        end
end

while d2>1e-10

iter = iter+1            % s is the # of iterations started.
for j=1:n_k
        for h=1:n_z
            [lp(j,h)]=sub_newton(max(kpp(j),kp(j)*(1-delta)+phi_bar*i_ss),kp(j),y(h)); %labor tomorrow
             R(j,h) = exp(y(h))*alpha*(kp(j)^(alpha-1))*lp(j,h)^(1-alpha)+1-delta;  %Capital's return
             mp(j,h) = exp(y(h))*(kp(j)^alpha)*(lp(j,h)^(1-alpha))+(1-delta)*kp(j); %cash in hand tomorrow
        end    
end
              

                               
    MUp = theta*(mp-max(kp.*(1-delta)*ones(1,n_z)+phi_bar*i_ss*ones(n_k,n_z),kpp)).^(-1);                % marginal utility tomorrow.
    c=((1/theta)*beta.*((R.*MUp-max(0,lambdap.*(1-delta)))*prob')).^(-1);    %consumption today when k'>(1-delta)k+ phi_bar*i_ss
    m = c+kp*(ones(1,n_z));                                 %cash in hand today when k'>(1-delta)k+ phi_bar*i_ss
    MU = theta.*cbind.^(-1);                                      %Marginal utility today when k'=(1-delta)k+ phi_bar*i_ss
    
    lambda=MU-beta.*(R.*MUp-max(0,lambdap.*(1-delta)))*prob'; 
    d2 = max(max(abs(m0-m)./(1+abs(m))))  ;                      % Update convergence measure.
    m0 = m;                                                      % Update initial value for cash on hand
    
      
            for i=1:n_z
                 kpp(:,i) = interp1(m(:,i),kp,mp(:,i),'pchip');  % Update the policy function by interpolation.
                 lambdap(:,i) = interp1(m(:,i),lambda(:,i),mp(:,i),'pchip');
            end
        
    
    
end
%values when constraint is nonbinding (lambda=0)
for i=1:n_k
    for j=1:n_z
          [x rc]=csolve('f_lk',[l_ss k_ss]',[],1e-7,1000,kp(i),c(i,j),y(j));
          l(i,j)=x(1,:);  k(i,j)=x(2,:);
          if l(i,j)<0.01 || l(i,j)>0.99
          l(i,j)=max(l(i,j),0.01);
          l(i,j)=min(l(i,j),0.99);
          k(i,j)=sub_kendogenousnewton(y(j),l(i,j),c(i,j),kp(i));
          
          end
    end
end

             %Finding the true policy functions over (k',z)
             g_k=min((kp*ones(1,n_z)-phi_bar*i_ss*ones(n_k,n_z))./(1-delta),k); 
             for j=1:n_k
                       for h=1:n_z
            [g_l(j,h)]=sub_newton(kp(j),g_k(j,h),y(h)); %labor
            [g_i(j,h)] = kp(j)-(1-delta)*g_k(j,h);
            [g_c(j,h)] = exp(y(h)).*(g_k(j,h).^alpha).*(g_l(j,h).^(1-alpha))-g_i(j,h); %consumption
            slack(j,h) =g_i(j,h)-phi_bar*i_ss;
               
                       end

             end
  
 lambda=theta.*g_c.^(-1)-beta.*((R.*MUp-max(0,lambdap.*(1-delta)))*prob');
 
 
end

