%Modified from the stoch_pi.m code of George Hall (July 2001, Yale University)
function [g_k,g_c,g_l,v,lambda]=sub_pfi(grid_k,n_k,n_z,y,transition,step0)

global delta alpha beta theta value_ss phi_bar i_ss 
 
prob=transition;
kp=grid_k';
k=grid_k';


labor=zeros(n_k,n_k,n_z);
cons=zeros(n_k,n_k,n_z);
d=zeros(n_k,n_z);
g_l=zeros(n_k,n_z);
g_c=zeros(n_k,n_z);

lambda=zeros(n_k,n_z);


for j=1:n_k
    for   i = 1:n_k
        for h = 1:n_z
            [labor(i,j,h)]=sub_newton(kp(i),k(j),y(h));  
             cons(i,j,h) = exp(y(h))*(k(j)^alpha)*(labor(i,j,h)^(1-alpha))+(1-delta)*k(j)-kp(i);
        end
    end
end


 cons(find(cons<=0)) = NaN;

 
 util =  theta.*log(cons)+(1-theta).*log(1-labor);


 util(find(isnan(util))) = -inf;



%  initialize some variables

v       = ones(n_k,n_z).*value_ss;
tv      = zeros(n_k,n_z);
decis   = zeros(n_k,n_z);
tdecis   = zeros(n_k,n_z);
metric  = 10;
iter = 0;
tme = cputime;

[rs,cs,hs] = size(util);
%
%  Solve for fixed point using policy iteration
%
while metric > 1e-6; 

    for h=1:n_z
    [tv(:,h),tdecis(:,h)]=max(util(:,:,h) + beta*repmat(v*prob(h,:)',1,n_k)); %unconstrained
    g_ktemp(:,h)=(tdecis(:,h)-1)*step0 + grid_k(1);                             %find k' maximizing the above
    g_k(:,h)=max(g_ktemp(:,h),k*(1-delta)+phi_bar*i_ss);                        %check if k'>=k(1-delta)k+phi iss
    
      for j=1:n_k
          [kpcon(j,h), indexcon(j,h)]=min(abs(g_k(j,h)-grid_k));                 %find the grid point for k'
    
           obj=util(:,:,h) + beta*repmat(v*prob(h,:)',1,n_k);
           tvcon(j,h)=obj(indexcon(j,h),j);                                       %adjust the value function
      end
    end
   
  tv=tvcon; tdecis=indexcon;
      
    
  r = zeros(cs,n_z);
 
  
  
  for i=1:cs
      for h=1:n_z
    r(i,h) = util(tdecis(i,h),i,h);
      end
  end
  rvec=reshape(r,cs*n_z,1);

  g=zeros(cs,cs,n_z);
  for i=1:cs
      for h=1:n_z
    g(i,tdecis(i,h),h)=1;
      end
  end

  trans=zeros(cs*n_z,cs*n_z);
  for h=1:n_z
     
      trans((h-1)*cs+1:h*cs,:)=kron(prob(h,:),g(:,:,h));
      
   end

  tv(:) = (speye(n_z*cs) - beta*trans)\rvec;    
  
  metric=max(max(abs((tv-v)./tv)));
  v=tv;
  decis=tdecis;
  
        
   iter = iter+1  
end
  
 
g_k=(decis-1)*step0 + grid_k(1);

for i=1:n_k
    for j=1:n_z
        
            [g_l(i,j)]=sub_newton(g_k(i,j),k(i),y(j));
            g_c(i,j) = exp(y(j))*(k(i)^alpha)*(g_l(i,j)^(1-alpha))+(1-delta)*k(i)-g_k(i,j);
                      
    end    
end

%Compute the derivative Vk using a linear system
d(1,:)=(v(2,:)-v(1,:))./step0;
d(n_k,:)=(v(n_k,:)-v(n_k-1,:))./step0;
for i = 2:n_k-1;
d(i,:)=(v(i+1,:)-v(i-1,:))./(2*step0);
end

%Compute the multiplier lambda on the investment contraint
for h=1:n_z
    for j=1:n_k
lambda(j,h) = (theta*(g_c(j,h)^(-1))*(exp(y(h))*alpha*k(j)^(alpha-1)*g_l(j,h)^(1-alpha)+1-delta)-d(j,h))/(1-delta);
    end
end


end

