function [meanerror1,meanerror2,maxerror1,maxerror2]=sub_simul(intertemporal_errors,intratemporal_errors,grid_k,g_k,g_l,g_c,transitioncdf,k_ss,y,do_stat)

global Tsimul delta alpha phi_bar i_ss
tsimul=Tsimul;

disp(' Starting simulations... ');

intertemporal_errorsim=zeros(1,tsimul);
intratemporal_errorsim=zeros(1,tsimul);
k_sim=zeros(1,tsimul);
i_sim=zeros(1,tsimul);
y_sim=zeros(1,tsimul);
c_sim=zeros(1,tsimul);
l_sim=zeros(1,tsimul);


%Specifies the initial level of capital and the productivity shock.
capital(1)=k_ss;
productivity=2;

intertemporal_errors=log10(abs(intertemporal_errors)); 
intratemporal_errors=log10(abs(intratemporal_errors)); 
intratemporal_errors(intratemporal_errors==-inf)=min(intratemporal_errors(isfinite(intratemporal_errors)));
for t=2:tsimul+1;
randomnumber= rand(1,1);
[intertemporal_errorsim(t-1)]=interp1(grid_k,intertemporal_errors(:,productivity),capital(1),'pchip');
[intratemporal_errorsim(t-1)]=interp1(grid_k,intratemporal_errors(:,productivity),capital(1),'pchip');
[capital(2)]=interp1(grid_k,g_k(:,productivity),capital(1),'pchip');
[cons_cur]=interp1(grid_k,g_c(:,productivity),capital(1),'pchip');
[labor_cur]=interp1(grid_k,g_l(:,productivity),capital(1),'pchip');
k_sim(t-1)=capital(1);
i_sim(t-1)=capital(2)-(1-delta)*capital(1);
y_sim(t-1)=exp(y(productivity))*capital(1)^alpha*labor_cur^(1-alpha);
c_sim(t-1)=cons_cur;
l_sim(t-1)=labor_cur;

if i_sim(t-1)-phi_bar*i_ss<.0001
t_bind(t-1)=1;
else
t_bind(t-1)=0;
end

[~,j ]=find(transitioncdf(productivity,:)>randomnumber,1);

productivity=j(1);
nn(t-1)=productivity;
capital(1)=capital(2);
end; 


meanerror1=mean(intertemporal_errorsim(1000:end));
meanerror2=mean(intratemporal_errorsim(1000:end));
maxerror1 = max(intertemporal_errorsim(1000:end));
maxerror2 = max(intratemporal_errorsim(1000:end));



%remove the first 1000 observations
y = y_sim(1000:end);
i = i_sim(1000:end);
h = l_sim(1000:end);
k = k_sim(1000:end);
c = c_sim(1000:end);
tb=t_bind(1000:end); ratio=sum(tb)/(length(t_bind)-1000);
% Compute the statistics
if do_stat==1
    
ystd = std(y)/mean(y);
istd = std(i)/mean(i);
hstd = std(h)/mean(h);
kstd = std(k)/mean(k);
cstd = std(c)/mean(c);

ystdy = ystd/ystd;
istdy = istd/ystd;
hstdy = hstd/ystd;
kstdy = kstd/ystd;
cstdy = cstd/ystd;

ycorry = corrcoef(y,y);
icorry = corrcoef(y,i);
hcorry = corrcoef(y,h);
kcorry = corrcoef(y,k);
ccorry = corrcoef(y,c);


fprintf(' \t Mean \t Std.dev. \t Std.dev. rel y \t Cont.corr y \n');
fprintf(' y \t %1.5f \t %1.5f \t %1.5f \t %1.5f \n', [mean(y) ystd ystdy ycorry(1,2)])
fprintf(' c \t %1.5f \t %1.5f \t %1.5f \t %1.5f \n', [mean(c) cstd cstdy ccorry(1,2)])
fprintf(' i \t %1.5f \t %1.5f \t %1.5f \t %1.5f \n', [mean(i) istd istdy icorry(1,2)])
fprintf(' h \t %1.5f \t %1.5f \t %1.5f \t %1.5f \n', [mean(h) hstd hstdy hcorry(1,2)])
fprintf(' k \t %1.5f \t %1.5f \t %1.5f \t %1.5f \n', [mean(k) kstd kstdy kcorry(1,2)])

end

fprintf(' The mean and max intertemporal Euler equation errors  \n');
fprintf('  \t %1.5f \t %1.5f \n',[meanerror1 maxerror1])
fprintf(' The mean and max intratemporal Euler equation errors \n');
fprintf('  \t %1.5f \t %1.5f \n',[meanerror2 maxerror2])


end 



